Installer - Feature #12635

Options to deploy Grub and PXELinux EFI loaders in TFTP root
11/30/2015 08:01 AM - Lukas Zapletal

Status: Closed
Priority: Normal
Assignee: Lukas Zapletal
Category: Foreman modules
Target version: 1.13.0
Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: Red Hat JIRA:
Pull request: https://github.com/theforeman/foreman-i
nstaller/pull/197,
https://github.com/theforeman/puppet-for
eman_proxy/pull/276

Description

It looks like Grub2 is the best and most compatible way of PXE booting EFI hardware and it is available in most Linux distributions. It
makes sense to provide support in our Puppet classes and installer to deploy these.

Puppet changes as follows:

if RHEL6 or Fedora 18 or older is found then

install grub package

create /var/lib/tftproot/grub/

copy /boot/efi/EFI/*/grub.efi to /var/lib/tftproot/grub/grubx64.efi
create a relative symlink shim.efi to /var/lib/tftproot/grub/grubx64.efi
ensure correct file permissions and SELinux context

if RHEL7 or Fedora 19 or newer is found then

install packages: grub2-efi grub2-efi-modules grub2-tools shim

create /var/lib/tftproot/grub2/

copy /boot/efi/EFI/*/shim.efi to /var/lib/tftproot/grub2/shim.efi

build grub2 with all modules with: grub2-mkimage -O x86_64-¢fi -d /usr/lib/grub/x86_64-efi -o /var/lib/tftproot/grub2/grubx64.efi -p "
“find /ustr/lib/grub/x86_64-¢efi/*.mod -printf "%f " | sed -e 'sA\.mod//g" (X)

ensure correct file permissions and SELinux context

if Debian or Ubuntu is found then

install packages: grub-common grub-efi-amd64-bin

create /var/lib/tftproot/grub2/

build grub2 with all modules with: grub-mkimage -O x86_64-efi -d /usr/lib/grub/x86_64-efi -o /var/lib/tftproot/grub2/grubx64.efi -p ™"
“find /usr/lib/grub/x86_64-efi/*.mod -printf "%f " | sed -e 'sA\.mod//g" (X)

create a relative symlink shim.efi to /var/lib/tftproot/grub/grubx64.efi

ensure correct file permissions

| have only tested this with latest LTS Ubuntu and Debian Jessie (8)

(X) - this command could be extracted to a helper script

Related issues:

Related to Foreman - Tracker #431: [TRACKER] UEFI PXE support Resolved

Related to Installer - Feature #14920: Change dhcpd.conf to support EFI loaders Closed 05/04/2016
Related to Katello - Bug #16820: Upgrading Katello 3.1 to 3.2 Error with /usr... Duplicate 10/06/2016
Related to Installer - Bug #16705: grubx64.efi fails to boot with Secure Boot Closed 09/27/2016

Associated revisions

Revision 78e5b783 - 09/09/2016 06:40 AM - Lukas Zapletal
Refs #12635 - added migration for new grub tftp dirs (#197)
History

#1 - 11/30/2015 08:02 AM - Lukas Zapletal

- Tracker changed from Bug to Feature

#2 - 11/30/2015 08:02 AM - Lukas Zapletal
- Related to Tracker #431: [TRACKER] UEFI PXE support added

#3 - 11/30/2015 08:35 AM - Lukas Zapletal

Also we can prepare configuration for POWERPC nodes:

http://jk.ozlabs.org/blog/post/158/netbooting-petitboot/?cm_mc_uid=91489629740814486170120&cm_mc_sid_50200000=1448888937

The only issue is Grub2-ppc binary, that will never be available on x86 distros, we can leave a comment that this will only work if smart-proxy is
running on POWER PC as well.

#4 - 05/04/2016 04:32 AM - Lukas Zapletal

- Subject changed from Dual PXELinux/Grub2 DHCP configuration with EFI firmware to Options to deploy Grub and PXELinux EF| loaders in TFTP
root

- Description updated

#5 - 05/04/2016 04:33 AM - Lukas Zapletal

Expected file paths are defined in the table at h

#6 - 05/04/2016 04:46 AM - Lukas Zapletal
- Related to Feature #14920: Change dhcpd.conf to support EFI loaders added

#7 - 05/04/2016 04:50 AM - Lukas Zapletal
UEFI shim shall be installed if possible.

#8 - 08/26/2016 04:36 AM - Lukas Zapletal

Deleted (moved to description).

#9 - 08/29/2016 05:57 AM - Lukas Zapletal

- Description updated

Updated description, changed from downloading
http://ftp.debian.org/debian/dists/jessie/main/installer-amd64/current/images/netboot/debian-installer/amd64/bootnetx64.efi and
http://archive.ubuntu.com/ubuntu/dists/trusty/main/uefi/grub2-amdeé4/current/grubnetx64.efi.signed to packages.

#10 - 08/31/2016 10:57 AM - Lukas Zapletal

- Description updated

Added missing shim package

#11 - 08/31/2016 12:01 PM - Lukas Zapletal

- Description updated

Removed grubx64s.efi copy, not really necessary.

#12 - 09/05/2016 03:55 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Lukas Zapletal

- Pull request https://github.com/theforeman/foreman-installer/pull/197 added

#13 - 09/06/2016 10:01 AM - Daniel Lobato Garcia

- Target version set to 1.6.2

#14 - 09/08/2016 02:58 AM - Dominic Cleal
http://jk.ozlabs.org/blog/post/158/netbooting-petitboot/?cm_mc_uid=91489629740814486170120&cm_mc_sid_50200000=1448888937
http://projects.theforeman.org/projects/foreman/wiki/PXE_Booting_UEFI
http://ftp.debian.org/debian/dists/jessie/main/installer-amd64/current/images/netboot/debian-installer/amd64/bootnetx64.efi
http://archive.ubuntu.com/ubuntu/dists/trusty/main/uefi/grub2-amd64/current/grubnetx64.efi.signed

- Status changed from Ready For Testing to Closed
- translation missing: en.field_release set to 160

- Pull request https://github.com/theforeman/puppet-foreman_proxy/pull/276 added

https://github.com/theforeman/puppet-foreman_proxy/commit/d5794d8d80b7a715be7ca0108f47ebaba7c4452b

#15 - 10/06/2016 09:30 AM - Anonymous
- Related to Bug #16820: Upgrading Katello 3.1 to 3.2 Error with /usr/bin/grub2-mkimage added

#16 - 11/16/2016 05:08 AM - Lukas Zapletal
- Related to Bug #16705: grubx64.efi fails to boot with Secure Boot added
